import 'package:flutter/material.dart';
import 'package:phone_form_field/l10n/generated/phone_field_localization.dart';
import 'package:phone_form_field/src/models/country.dart';

class CountryTranslator {
  static Map _countryNames = {
    'AD': (ctx) => PhoneFieldLocalization.of(ctx)?.ad_,
    'AE': (ctx) => PhoneFieldLocalization.of(ctx)?.ae_,
    'AF': (ctx) => PhoneFieldLocalization.of(ctx)?.af_,
    'AG': (ctx) => PhoneFieldLocalization.of(ctx)?.ag_,
    'AI': (ctx) => PhoneFieldLocalization.of(ctx)?.ai_,
    'AL': (ctx) => PhoneFieldLocalization.of(ctx)?.al_,
    'AM': (ctx) => PhoneFieldLocalization.of(ctx)?.am_,
    'AN': (ctx) => PhoneFieldLocalization.of(ctx)?.an_,
    'AO': (ctx) => PhoneFieldLocalization.of(ctx)?.ao_,
    'AQ': (ctx) => PhoneFieldLocalization.of(ctx)?.aq_,
    'AR': (ctx) => PhoneFieldLocalization.of(ctx)?.ar_,
    'AS': (ctx) => PhoneFieldLocalization.of(ctx)?.as_,
    'AT': (ctx) => PhoneFieldLocalization.of(ctx)?.at_,
    'AU': (ctx) => PhoneFieldLocalization.of(ctx)?.au_,
    'AW': (ctx) => PhoneFieldLocalization.of(ctx)?.aw_,
    'AX': (ctx) => PhoneFieldLocalization.of(ctx)?.ax_,
    'AZ': (ctx) => PhoneFieldLocalization.of(ctx)?.az_,
    'BA': (ctx) => PhoneFieldLocalization.of(ctx)?.ba_,
    'BB': (ctx) => PhoneFieldLocalization.of(ctx)?.bb_,
    'BD': (ctx) => PhoneFieldLocalization.of(ctx)?.bd_,
    'BE': (ctx) => PhoneFieldLocalization.of(ctx)?.be_,
    'BF': (ctx) => PhoneFieldLocalization.of(ctx)?.bf_,
    'BG': (ctx) => PhoneFieldLocalization.of(ctx)?.bg_,
    'BH': (ctx) => PhoneFieldLocalization.of(ctx)?.bh_,
    'BI': (ctx) => PhoneFieldLocalization.of(ctx)?.bi_,
    'BJ': (ctx) => PhoneFieldLocalization.of(ctx)?.bj_,
    'BL': (ctx) => PhoneFieldLocalization.of(ctx)?.bl_,
    'BM': (ctx) => PhoneFieldLocalization.of(ctx)?.bm_,
    'BN': (ctx) => PhoneFieldLocalization.of(ctx)?.bn_,
    'BO': (ctx) => PhoneFieldLocalization.of(ctx)?.bo_,
    'BR': (ctx) => PhoneFieldLocalization.of(ctx)?.br_,
    'BS': (ctx) => PhoneFieldLocalization.of(ctx)?.bs_,
    'BT': (ctx) => PhoneFieldLocalization.of(ctx)?.bt_,
    'BW': (ctx) => PhoneFieldLocalization.of(ctx)?.bw_,
    'BY': (ctx) => PhoneFieldLocalization.of(ctx)?.by_,
    'BZ': (ctx) => PhoneFieldLocalization.of(ctx)?.bz_,
    'CA': (ctx) => PhoneFieldLocalization.of(ctx)?.ca_,
    'CC': (ctx) => PhoneFieldLocalization.of(ctx)?.cc_,
    'CD': (ctx) => PhoneFieldLocalization.of(ctx)?.cd_,
    'CF': (ctx) => PhoneFieldLocalization.of(ctx)?.cf_,
    'CG': (ctx) => PhoneFieldLocalization.of(ctx)?.cg_,
    'CH': (ctx) => PhoneFieldLocalization.of(ctx)?.ch_,
    'CI': (ctx) => PhoneFieldLocalization.of(ctx)?.ci_,
    'CK': (ctx) => PhoneFieldLocalization.of(ctx)?.ck_,
    'CL': (ctx) => PhoneFieldLocalization.of(ctx)?.cl_,
    'CM': (ctx) => PhoneFieldLocalization.of(ctx)?.cm_,
    'CN': (ctx) => PhoneFieldLocalization.of(ctx)?.cn_,
    'CO': (ctx) => PhoneFieldLocalization.of(ctx)?.co_,
    'CR': (ctx) => PhoneFieldLocalization.of(ctx)?.cr_,
    'CU': (ctx) => PhoneFieldLocalization.of(ctx)?.cu_,
    'CV': (ctx) => PhoneFieldLocalization.of(ctx)?.cv_,
    'CX': (ctx) => PhoneFieldLocalization.of(ctx)?.cx_,
    'CY': (ctx) => PhoneFieldLocalization.of(ctx)?.cy_,
    'CZ': (ctx) => PhoneFieldLocalization.of(ctx)?.cz_,
    'DE': (ctx) => PhoneFieldLocalization.of(ctx)?.de_,
    'DJ': (ctx) => PhoneFieldLocalization.of(ctx)?.dj_,
    'DK': (ctx) => PhoneFieldLocalization.of(ctx)?.dk_,
    'DM': (ctx) => PhoneFieldLocalization.of(ctx)?.dm_,
    'DO': (ctx) => PhoneFieldLocalization.of(ctx)?.do_,
    'DZ': (ctx) => PhoneFieldLocalization.of(ctx)?.dz_,
    'EC': (ctx) => PhoneFieldLocalization.of(ctx)?.ec_,
    'EE': (ctx) => PhoneFieldLocalization.of(ctx)?.ee_,
    'EG': (ctx) => PhoneFieldLocalization.of(ctx)?.eg_,
    'ER': (ctx) => PhoneFieldLocalization.of(ctx)?.er_,
    'ES': (ctx) => PhoneFieldLocalization.of(ctx)?.es_,
    'ET': (ctx) => PhoneFieldLocalization.of(ctx)?.et_,
    'FI': (ctx) => PhoneFieldLocalization.of(ctx)?.fi_,
    'FJ': (ctx) => PhoneFieldLocalization.of(ctx)?.fj_,
    'FK': (ctx) => PhoneFieldLocalization.of(ctx)?.fk_,
    'FM': (ctx) => PhoneFieldLocalization.of(ctx)?.fm_,
    'FO': (ctx) => PhoneFieldLocalization.of(ctx)?.fo_,
    'FR': (ctx) => PhoneFieldLocalization.of(ctx)?.fr_,
    'GA': (ctx) => PhoneFieldLocalization.of(ctx)?.ga_,
    'GB': (ctx) => PhoneFieldLocalization.of(ctx)?.gb_,
    'GD': (ctx) => PhoneFieldLocalization.of(ctx)?.gd_,
    'GE': (ctx) => PhoneFieldLocalization.of(ctx)?.ge_,
    'GF': (ctx) => PhoneFieldLocalization.of(ctx)?.gf_,
    'GG': (ctx) => PhoneFieldLocalization.of(ctx)?.gg_,
    'GH': (ctx) => PhoneFieldLocalization.of(ctx)?.gh_,
    'GI': (ctx) => PhoneFieldLocalization.of(ctx)?.gi_,
    'GL': (ctx) => PhoneFieldLocalization.of(ctx)?.gl_,
    'GM': (ctx) => PhoneFieldLocalization.of(ctx)?.gm_,
    'GN': (ctx) => PhoneFieldLocalization.of(ctx)?.gn_,
    'GP': (ctx) => PhoneFieldLocalization.of(ctx)?.gp_,
    'GQ': (ctx) => PhoneFieldLocalization.of(ctx)?.gq_,
    'GR': (ctx) => PhoneFieldLocalization.of(ctx)?.gr_,
    'GS': (ctx) => PhoneFieldLocalization.of(ctx)?.gs_,
    'GT': (ctx) => PhoneFieldLocalization.of(ctx)?.gt_,
    'GU': (ctx) => PhoneFieldLocalization.of(ctx)?.gu_,
    'GW': (ctx) => PhoneFieldLocalization.of(ctx)?.gw_,
    'GY': (ctx) => PhoneFieldLocalization.of(ctx)?.gy_,
    'HK': (ctx) => PhoneFieldLocalization.of(ctx)?.hk_,
    'HN': (ctx) => PhoneFieldLocalization.of(ctx)?.hn_,
    'HR': (ctx) => PhoneFieldLocalization.of(ctx)?.hr_,
    'HT': (ctx) => PhoneFieldLocalization.of(ctx)?.ht_,
    'HU': (ctx) => PhoneFieldLocalization.of(ctx)?.hu_,
    'ID': (ctx) => PhoneFieldLocalization.of(ctx)?.id_,
    'IE': (ctx) => PhoneFieldLocalization.of(ctx)?.ie_,
    'IL': (ctx) => PhoneFieldLocalization.of(ctx)?.il_,
    'IM': (ctx) => PhoneFieldLocalization.of(ctx)?.im_,
    'IN': (ctx) => PhoneFieldLocalization.of(ctx)?.in_,
    'IO': (ctx) => PhoneFieldLocalization.of(ctx)?.io_,
    'IQ': (ctx) => PhoneFieldLocalization.of(ctx)?.iq_,
    'IR': (ctx) => PhoneFieldLocalization.of(ctx)?.ir_,
    'IS': (ctx) => PhoneFieldLocalization.of(ctx)?.is_,
    'IT': (ctx) => PhoneFieldLocalization.of(ctx)?.it_,
    'JE': (ctx) => PhoneFieldLocalization.of(ctx)?.je_,
    'JM': (ctx) => PhoneFieldLocalization.of(ctx)?.jm_,
    'JO': (ctx) => PhoneFieldLocalization.of(ctx)?.jo_,
    'JP': (ctx) => PhoneFieldLocalization.of(ctx)?.jp_,
    'KE': (ctx) => PhoneFieldLocalization.of(ctx)?.ke_,
    'KG': (ctx) => PhoneFieldLocalization.of(ctx)?.kg_,
    'KH': (ctx) => PhoneFieldLocalization.of(ctx)?.kh_,
    'KI': (ctx) => PhoneFieldLocalization.of(ctx)?.ki_,
    'KM': (ctx) => PhoneFieldLocalization.of(ctx)?.km_,
    'KN': (ctx) => PhoneFieldLocalization.of(ctx)?.kn_,
    'KP': (ctx) => PhoneFieldLocalization.of(ctx)?.kp_,
    'KR': (ctx) => PhoneFieldLocalization.of(ctx)?.kr_,
    'KW': (ctx) => PhoneFieldLocalization.of(ctx)?.kw_,
    'KY': (ctx) => PhoneFieldLocalization.of(ctx)?.ky_,
    'KZ': (ctx) => PhoneFieldLocalization.of(ctx)?.kz_,
    'LA': (ctx) => PhoneFieldLocalization.of(ctx)?.la_,
    'LB': (ctx) => PhoneFieldLocalization.of(ctx)?.lb_,
    'LC': (ctx) => PhoneFieldLocalization.of(ctx)?.lc_,
    'LI': (ctx) => PhoneFieldLocalization.of(ctx)?.li_,
    'LK': (ctx) => PhoneFieldLocalization.of(ctx)?.lk_,
    'LR': (ctx) => PhoneFieldLocalization.of(ctx)?.lr_,
    'LS': (ctx) => PhoneFieldLocalization.of(ctx)?.ls_,
    'LT': (ctx) => PhoneFieldLocalization.of(ctx)?.lt_,
    'LU': (ctx) => PhoneFieldLocalization.of(ctx)?.lu_,
    'LV': (ctx) => PhoneFieldLocalization.of(ctx)?.lv_,
    'LY': (ctx) => PhoneFieldLocalization.of(ctx)?.ly_,
    'MA': (ctx) => PhoneFieldLocalization.of(ctx)?.ma_,
    'MC': (ctx) => PhoneFieldLocalization.of(ctx)?.mc_,
    'MD': (ctx) => PhoneFieldLocalization.of(ctx)?.md_,
    'ME': (ctx) => PhoneFieldLocalization.of(ctx)?.me_,
    'MF': (ctx) => PhoneFieldLocalization.of(ctx)?.mf_,
    'MG': (ctx) => PhoneFieldLocalization.of(ctx)?.mg_,
    'MH': (ctx) => PhoneFieldLocalization.of(ctx)?.mh_,
    'MK': (ctx) => PhoneFieldLocalization.of(ctx)?.mk_,
    'ML': (ctx) => PhoneFieldLocalization.of(ctx)?.ml_,
    'MM': (ctx) => PhoneFieldLocalization.of(ctx)?.mm_,
    'MN': (ctx) => PhoneFieldLocalization.of(ctx)?.mn_,
    'MO': (ctx) => PhoneFieldLocalization.of(ctx)?.mo_,
    'MP': (ctx) => PhoneFieldLocalization.of(ctx)?.mp_,
    'MQ': (ctx) => PhoneFieldLocalization.of(ctx)?.mq_,
    'MR': (ctx) => PhoneFieldLocalization.of(ctx)?.mr_,
    'MS': (ctx) => PhoneFieldLocalization.of(ctx)?.ms_,
    'MT': (ctx) => PhoneFieldLocalization.of(ctx)?.mt_,
    'MU': (ctx) => PhoneFieldLocalization.of(ctx)?.mu_,
    'MV': (ctx) => PhoneFieldLocalization.of(ctx)?.mv_,
    'MW': (ctx) => PhoneFieldLocalization.of(ctx)?.mw_,
    'MX': (ctx) => PhoneFieldLocalization.of(ctx)?.mx_,
    'MY': (ctx) => PhoneFieldLocalization.of(ctx)?.my_,
    'MZ': (ctx) => PhoneFieldLocalization.of(ctx)?.mz_,
    'NA': (ctx) => PhoneFieldLocalization.of(ctx)?.na_,
    'NC': (ctx) => PhoneFieldLocalization.of(ctx)?.nc_,
    'NE': (ctx) => PhoneFieldLocalization.of(ctx)?.ne_,
    'NF': (ctx) => PhoneFieldLocalization.of(ctx)?.nf_,
    'NG': (ctx) => PhoneFieldLocalization.of(ctx)?.ng_,
    'NI': (ctx) => PhoneFieldLocalization.of(ctx)?.ni_,
    'NL': (ctx) => PhoneFieldLocalization.of(ctx)?.nl_,
    'NO': (ctx) => PhoneFieldLocalization.of(ctx)?.no_,
    'NP': (ctx) => PhoneFieldLocalization.of(ctx)?.np_,
    'NR': (ctx) => PhoneFieldLocalization.of(ctx)?.nr_,
    'NU': (ctx) => PhoneFieldLocalization.of(ctx)?.nu_,
    'NZ': (ctx) => PhoneFieldLocalization.of(ctx)?.nz_,
    'OM': (ctx) => PhoneFieldLocalization.of(ctx)?.om_,
    'PA': (ctx) => PhoneFieldLocalization.of(ctx)?.pa_,
    'PE': (ctx) => PhoneFieldLocalization.of(ctx)?.pe_,
    'PF': (ctx) => PhoneFieldLocalization.of(ctx)?.pf_,
    'PG': (ctx) => PhoneFieldLocalization.of(ctx)?.pg_,
    'PH': (ctx) => PhoneFieldLocalization.of(ctx)?.ph_,
    'PK': (ctx) => PhoneFieldLocalization.of(ctx)?.pk_,
    'PL': (ctx) => PhoneFieldLocalization.of(ctx)?.pl_,
    'PM': (ctx) => PhoneFieldLocalization.of(ctx)?.pm_,
    'PN': (ctx) => PhoneFieldLocalization.of(ctx)?.pn_,
    'PR': (ctx) => PhoneFieldLocalization.of(ctx)?.pr_,
    'PS': (ctx) => PhoneFieldLocalization.of(ctx)?.ps_,
    'PT': (ctx) => PhoneFieldLocalization.of(ctx)?.pt_,
    'PW': (ctx) => PhoneFieldLocalization.of(ctx)?.pw_,
    'PY': (ctx) => PhoneFieldLocalization.of(ctx)?.py_,
    'QA': (ctx) => PhoneFieldLocalization.of(ctx)?.qa_,
    'RE': (ctx) => PhoneFieldLocalization.of(ctx)?.re_,
    'RO': (ctx) => PhoneFieldLocalization.of(ctx)?.ro_,
    'RS': (ctx) => PhoneFieldLocalization.of(ctx)?.rs_,
    'RU': (ctx) => PhoneFieldLocalization.of(ctx)?.ru_,
    'RW': (ctx) => PhoneFieldLocalization.of(ctx)?.rw_,
    'SA': (ctx) => PhoneFieldLocalization.of(ctx)?.sa_,
    'SB': (ctx) => PhoneFieldLocalization.of(ctx)?.sb_,
    'SC': (ctx) => PhoneFieldLocalization.of(ctx)?.sc_,
    'SD': (ctx) => PhoneFieldLocalization.of(ctx)?.sd_,
    'SE': (ctx) => PhoneFieldLocalization.of(ctx)?.se_,
    'SG': (ctx) => PhoneFieldLocalization.of(ctx)?.sg_,
    'SH': (ctx) => PhoneFieldLocalization.of(ctx)?.sh_,
    'SI': (ctx) => PhoneFieldLocalization.of(ctx)?.si_,
    'SJ': (ctx) => PhoneFieldLocalization.of(ctx)?.sj_,
    'SK': (ctx) => PhoneFieldLocalization.of(ctx)?.sk_,
    'SL': (ctx) => PhoneFieldLocalization.of(ctx)?.sl_,
    'SM': (ctx) => PhoneFieldLocalization.of(ctx)?.sm_,
    'SN': (ctx) => PhoneFieldLocalization.of(ctx)?.sn_,
    'SO': (ctx) => PhoneFieldLocalization.of(ctx)?.so_,
    'SR': (ctx) => PhoneFieldLocalization.of(ctx)?.sr_,
    'SS': (ctx) => PhoneFieldLocalization.of(ctx)?.ss_,
    'ST': (ctx) => PhoneFieldLocalization.of(ctx)?.st_,
    'SV': (ctx) => PhoneFieldLocalization.of(ctx)?.sv_,
    'SY': (ctx) => PhoneFieldLocalization.of(ctx)?.sy_,
    'SZ': (ctx) => PhoneFieldLocalization.of(ctx)?.sz_,
    'TC': (ctx) => PhoneFieldLocalization.of(ctx)?.tc_,
    'TD': (ctx) => PhoneFieldLocalization.of(ctx)?.td_,
    'TG': (ctx) => PhoneFieldLocalization.of(ctx)?.tg_,
    'TH': (ctx) => PhoneFieldLocalization.of(ctx)?.th_,
    'TJ': (ctx) => PhoneFieldLocalization.of(ctx)?.tj_,
    'TK': (ctx) => PhoneFieldLocalization.of(ctx)?.tk_,
    'TL': (ctx) => PhoneFieldLocalization.of(ctx)?.tl_,
    'TM': (ctx) => PhoneFieldLocalization.of(ctx)?.tm_,
    'TN': (ctx) => PhoneFieldLocalization.of(ctx)?.tn_,
    'TO': (ctx) => PhoneFieldLocalization.of(ctx)?.to_,
    'TR': (ctx) => PhoneFieldLocalization.of(ctx)?.tr_,
    'TT': (ctx) => PhoneFieldLocalization.of(ctx)?.tt_,
    'TV': (ctx) => PhoneFieldLocalization.of(ctx)?.tv_,
    'TW': (ctx) => PhoneFieldLocalization.of(ctx)?.tw_,
    'TZ': (ctx) => PhoneFieldLocalization.of(ctx)?.tz_,
    'UA': (ctx) => PhoneFieldLocalization.of(ctx)?.ua_,
    'UG': (ctx) => PhoneFieldLocalization.of(ctx)?.ug_,
    'US': (ctx) => PhoneFieldLocalization.of(ctx)?.us_,
    'UY': (ctx) => PhoneFieldLocalization.of(ctx)?.uy_,
    'UZ': (ctx) => PhoneFieldLocalization.of(ctx)?.uz_,
    'VA': (ctx) => PhoneFieldLocalization.of(ctx)?.va_,
    'VC': (ctx) => PhoneFieldLocalization.of(ctx)?.vc_,
    'VE': (ctx) => PhoneFieldLocalization.of(ctx)?.ve_,
    'VG': (ctx) => PhoneFieldLocalization.of(ctx)?.vg_,
    'VI': (ctx) => PhoneFieldLocalization.of(ctx)?.vi_,
    'VN': (ctx) => PhoneFieldLocalization.of(ctx)?.vn_,
    'VU': (ctx) => PhoneFieldLocalization.of(ctx)?.vu_,
    'WF': (ctx) => PhoneFieldLocalization.of(ctx)?.wf_,
    'WS': (ctx) => PhoneFieldLocalization.of(ctx)?.ws_,
    'YE': (ctx) => PhoneFieldLocalization.of(ctx)?.ye_,
    'YT': (ctx) => PhoneFieldLocalization.of(ctx)?.yt_,
    'ZA': (ctx) => PhoneFieldLocalization.of(ctx)?.za_,
    'ZM': (ctx) => PhoneFieldLocalization.of(ctx)?.zm_,
    'ZW': (ctx) => PhoneFieldLocalization.of(ctx)?.zw_
  };

  /// Localised name depending on the current application locale
  /// If you have many LocalisedName to handle in a same context, consider
  /// supplying the second optional PhoneFieldLocalization to avoid
  /// walking up the widget to get [PhoneFieldLocalization] instance
  /// for each call.
  static String localisedName(
    BuildContext context,
    Country country,
  ) {
    String? name = getCountryNameForIsoCode(context, country.isoCode);
    return name ?? country.name;
  }

  static String? getCountryNameForIsoCode(BuildContext ctx, String isoCode) {
    final Function(BuildContext)? translateFn =
        _countryNames[isoCode.toUpperCase()];
    return translateFn?.call(ctx);
  }
}
